/**
 * Copyright (C) 2003-2005 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
 */

package sync4j.syncclient.spds;

/**
 * This exception represents the base exception for synchronization engine
 * related error conditions.
 *
 * @author  Fabio Maggi @ Funambol
 * @version $Id: SyncException.java,v 1.1.1.1.2.1 2005/01/27 11:00:58 fabius Exp $
 */
public class SyncException extends Exception {

    private Throwable cause = null;

    /**
     * Creates a new instance of <code>SyncException</code> without detail message.
     */
    public SyncException() {
    }


    /**
     * Constructs an instance of <code>SyncException</code> with the specified detail message.
     * @param msg the detail message.
     */
    public SyncException(String msg) {
        super(msg);
    }

    /**
     * Constructs an instance of <code>SyncException</code> with the specified detail message
     * and root cause.
     *
     * @param msg the detail message.
     * @param cause the root cause
     */
    public SyncException(final String msg, final Throwable cause) {
        this(msg);
        this.cause = cause;
    }

    /**
     * Retrieves the cause of this exception
     *
     * @return the cause of this exception or null if it is not due to another exception.
     */
    public Throwable getCause() {
        return cause;
    }

    /**
     * Print exception and cause stack trace to the standard error stream
     */
    public void printStackTrace() {
        super.printStackTrace();
        if (cause != null) {
            System.err.println("Caused by:");
            cause.printStackTrace();
        }
    }
}